#Include "FiveWin.ch"
#Include "xBrowse.ch"

FUNCTION TST_SQL_CEP_TMP01()
  Local oTst
  
  oTst := TstSqlCepTmp01():New()
  oTst:Display()

RETURN NIL

Class TstSqlCepTmp01

  Data oDt_CepCidades, oDt_CepEndereco
  Data oDlgTst, oBrw261_CepsCidades, oBrw262_CepsEnderecos
  
  Method New() Constructor
  Method End()
  Method Display()
  
EndClass
//-----------------------------------------------------------------------------
Method New() Class TstSqlCepTmp01

  ::oDt_CepCidades  := tAds():DsNew(1,1) // 1-Definir query com retorno de Cursors (Handle) / Usar conexo de numero 1
  ::oDt_CepCidades:cQrySql := "Select {static} DISTINCT CIDADE, ESTADO from TB_CEP Order By CIDADE "
  ::oDt_CepCidades:lDsCursorsToTemp := .T. // Busca o conteudo e gera um arquivo temporario com indices
  ::oDt_CepCidades:aFieldsTempIndex := {"CIDADE"} // Chaves de Indice a ser criado
  
  ::oDt_CepEndereco := tAds():DsNew(1,1) // Usando a classe gerada em DataBase_TB_CEP.prg
  ::oDt_CepEndereco:cQrySql := "Select {static} * From TB_CEP Where CIDADE = _CIDADE_ Order By ENDERECO, COMPL"
  aadd(::oDt_CepEndereco:aVarsSql,{"_CIDADE_",{||::oDt_CepCidades:VarGet("CIDADE")}})  
  ::oDt_CepEndereco:lDsCursorsToTemp := .T. // Busca o conteudo e gera um arquivo temporario com indices
  ::oDt_CepEndereco:aFieldsTempIndex := {"CIDADE","ENDERECO","COMPL"} // Chaves de Indice a ser criado

Return Self
//-----------------------------------------------------------------------------
Method End() Class TstSqlCepTmp01

  ::oDt_CepCidades:End()
  ::oDt_CepEndereco:End()

Return .T.
//-----------------------------------------------------------------------------
Method Display() Class TstSqlCepTmp01
  Local aColunas := {}, nColTmp := 0
  Local oSelf := Self, aVarsFormat := {}

  ::oDt_CepCidades:DsExecute(100) // 100- Cache tipo Page de Advantage
  ::oDt_CepEndereco:DsExecute(300) // 300- Cache tipo Page de Advantage

	Define Dialog ::oDlgTst Resource "TST_SQL_CEPS_TMP" ;
			Title "Teste com Tabela TB_CEP usando SQL e copiando para temporarios / Non Modal"


    ::oBrw261_CepsCidades                     := tXBrowse():New( ::oDlgTst )
    ::oBrw261_CepsCidades:cAlias              := ::oDt_CepCidades:cAlias
    ::oBrw261_CepsCidades:nMarqueeStyle       := MARQSTYLE_HIGHLROW
    ::oBrw261_CepsCidades:nRowDividerStyle    := LINESTYLE_BLACK
    ::oBrw261_CepsCidades:nColDividerStyle    := LINESTYLE_BLACK
    ::oBrw261_CepsCidades:nColSel             := 1
    ::oBrw261_CepsCidades:l2007               := .T.
    ::oBrw261_CepsCidades:nRowHeight          := 24
    ::oBrw261_CepsCidades:bClrRowFocus        := {||{ GetSysColor( 9 ), GetSysColor( 16 )}}
    ::oBrw261_CepsCidades:lFooter             := .F.
		::oBrw261_CepsCidades:bChange := {|| ::oDt_CepEndereco:DsExecute(300),;
		                                     ::oDt_CepEndereco:GoTop(),;
		                                     ::oBrw262_CepsEnderecos:GoTop(),;
		                                     ::oBrw262_CepsEnderecos:Refresh(.T.) }
  
  
      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw261_CepsCidades:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepCidades:VarGet("CIDADE")}
          :cHeader          := "Cidade "
          :nWidth           := 180
          :nDataStrAlign    := AL_LEFT
          :nHeadStrAlign    := AL_LEFT
          :cSortOrder       := "CIDADE"
          :nEditType        := EDIT_GET
          :cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          :AddResource("B16_BRWSEEK") // Bitmaps
          :nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|}
          :bOnPostEdit      := {|ooBj,vVar,nKey|{ooBj:Setorder(),;
                                                 ::oDt_CepCidades:Seek(vVar,"CIDADE",.T.),;
                                                 IF(::oDt_CepCidades:Eof(),;
                                                    {MsgAlert("Ocorrencia no Encontrada: "+Alltrim(vVar),"Ateno"),;
                                                     ::oDt_CepCidades:GoTop(),;
                                                     ::oBrw261_CepsCidades:GoTop()},;
                                                     Eval(::oBrw261_CepsCidades:bChange)),;
                                                 ::oBrw261_CepsCidades:Refresh()}}
        
        End With 

      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw261_CepsCidades:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepCidades:VarGet("ESTADO")}
          :cHeader          := "UF "
          :nWidth           := 36
          :nDataStrAlign    := AL_CENTER
          :nHeadStrAlign    := AL_CENTER
          //:cSortOrder       := "cDescricao"
          //:nEditType        := EDIT_GET
          //:cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          //:AddResource("B16_BRWSEEK") // Bitmaps
          //:AddResource("B16_LED_RED_1") // Bitmaps
          //:nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|::Fun_Menus(01,oSelf)}
          //:bOnPostEdit      := {|ooBj,vVar,nKey|::oCtrl261_ProdutosConsignados:MySeek(ooBj,vVar)}
        
        End With 

    ::oBrw261_CepsCidades:SetRDD()
    ::oBrw261_CepsCidades:CreateFromResource(261)
      
    aColunas[1]:SetOrder()
    ::oDt_CepCidades:Gotop()
    ::oBrw261_CepsCidades:Gotop()

  /////////////////////////// Endereos
  
    aColunas := {}
    
 
    ::oBrw262_CepsEnderecos                     := tXBrowse():New( ::oDlgTst )
    ::oBrw262_CepsEnderecos:cAlias              := ::oDt_CepEndereco:cAlias
    ::oBrw262_CepsEnderecos:nMarqueeStyle       := MARQSTYLE_HIGHLROW
    ::oBrw262_CepsEnderecos:nRowDividerStyle    := LINESTYLE_BLACK
    ::oBrw262_CepsEnderecos:nColDividerStyle    := LINESTYLE_BLACK
    ::oBrw262_CepsEnderecos:nColSel             := 2
    ::oBrw262_CepsEnderecos:l2007               := .T.
    ::oBrw262_CepsEnderecos:nRowHeight          := 24
    ::oBrw262_CepsEnderecos:bClrRowFocus        := {||{ GetSysColor( 9 ), GetSysColor( 16 )}}
    ::oBrw262_CepsEnderecos:lFooter             := .F.
  
     aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw262_CepsEnderecos:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepEndereco:VarGet("CEP")}
          :cHeader          := "Cep "
          :nWidth           := 80
          :nDataStrAlign    := AL_RIGHT
          :nHeadStrAlign    := AL_RIGHT
          :cSortOrder       := "CEP"
          :nEditType        := EDIT_GET
          :cEditPicture     := "99999-999"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          :AddResource("B16_BRWSEEK") // Bitmaps
          :nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|}
          :bOnPostEdit      := {|ooBj,vVar,nKey|{ooBj:Setorder(),;
                                                 ::oDt_CepEndereco:Seek(vVar,"CEP",.F.),;
                                                 IF(::oDt_CepEndereco:Eof(),;
                                                    {MsgAlert("Ocorrencia no Encontrada: "+Alltrim(vVar),"Ateno"),;
                                                     ::oDt_CepEndereco:GoTop(),;
                                                     ::oBrw262_CepsEnderecos:GoTop()},;
                                                     Nil),;
                                                 ::oBrw262_CepsEnderecos:Refresh()}}
        End With 

      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw262_CepsEnderecos:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepEndereco:VarGet("ENDERECO")}
          :cHeader          := "Endereo "
          :nWidth           := 230
          :nDataStrAlign    := AL_LEFT
          :nHeadStrAlign    := AL_LEFT
          :cSortOrder       := "ENDERECO"
          :nEditType        := EDIT_GET
          :cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          :AddResource("B16_BRWSEEK") // Bitmaps
          //:AddResource("B16_LED_RED_1") // Bitmaps
          :nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|::Fun_Menus(01,oSelf)}
          :bOnPostEdit      := {|ooBj,vVar,nKey|{ooBj:Setorder(),;
                                                 ::oDt_CepEndereco:Seek(vVar,"ENDERECO",.T.),;
                                                 IF(::oDt_CepEndereco:Eof(),;
                                                    {MsgAlert("Ocorrencia no Encontrada: "+Alltrim(vVar),"Ateno"),;
                                                     ::oDt_CepEndereco:GoTop(),;
                                                     ::oBrw262_CepsEnderecos:GoTop()},;
                                                     Nil),;
                                                 ::oBrw262_CepsEnderecos:Refresh()}}
        
        End With 

      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw262_CepsEnderecos:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepEndereco:VarGet("COMPL")}
          :cHeader          := "Complemento "
          :nWidth           := 210
          :nDataStrAlign    := AL_LEFT
          :nHeadStrAlign    := AL_LEFT
          :cSortOrder       := "COMPL"
          :nEditType        := EDIT_GET
          :cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          :AddResource("B16_BRWSEEK") // Bitmaps
          //:AddResource("B16_LED_RED_1") // Bitmaps
          :nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|::Fun_Menus(01,oSelf)}
          :bOnPostEdit      := {|ooBj,vVar,nKey|{ooBj:Setorder(),;
                                                 ::oDt_CepEndereco:Seek(vVar,"COMPL",.T.),;
                                                 IF(::oDt_CepEndereco:Eof(),;
                                                    {MsgAlert("Ocorrencia no Encontrada: "+Alltrim(vVar),"Ateno"),;
                                                     ::oDt_CepEndereco:GoTop(),;
                                                     ::oBrw262_CepsEnderecos:GoTop()},;
                                                     Nil),;
                                                 ::oBrw262_CepsEnderecos:Refresh()}}
        
        End With 

      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw262_CepsEnderecos:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepEndereco:VarGet("CIDADE")}
          :cHeader          := "Cidade "
          :nWidth           := 100
          :nDataStrAlign    := AL_LEFT
          :nHeadStrAlign    := AL_LEFT
          //:cSortOrder       := "cDescricao"
          //:nEditType        := EDIT_GET
          //:cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          //:AddResource("B16_BRWSEEK") // Bitmaps
          //:AddResource("B16_LED_RED_1") // Bitmaps
          //:nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|::Fun_Menus(01,oSelf)}
          //:bOnPostEdit      := {|ooBj,vVar,nKey|::oCtrl261_ProdutosConsignados:MySeek(ooBj,vVar)}
        
        End With 

      aadd(aColunas,Nil)
      nColTmp := Len(aColunas)
      aColunas[nColTmp] := ::oBrw262_CepsEnderecos:AddCol()
        With Object aColunas[nColTmp]
          :bStrData         := {||::oDt_CepEndereco:VarGet("ESTADO")}
          :cHeader          := "UF "
          :nWidth           := 36
          :nDataStrAlign    := AL_CENTER
          :nHeadStrAlign    := AL_CENTER
          //:cSortOrder       := "cDescricao"
          //:nEditType        := EDIT_GET
          //:cEditPicture     := "@!"
          //:bEditValue       := {||}
          //:bEditWhen        := {||}
          //:bEditValid       := {||}
          //:aEditListTxt     := {}
          //:AddResource("B16_BRWSEEK") // Bitmaps
          //:AddResource("B16_LED_RED_1") // Bitmaps
          //:nHeadBmpNo       := 1 
          //:bBmpData         := {||}
          //:nBtnBmp          := 2
          //:bEditBlock       := {|oSelf|::Fun_Menus(01,oSelf)}
          //:bOnPostEdit      := {|ooBj,vVar,nKey|::oCtrl261_ProdutosConsignados:MySeek(ooBj,vVar)}
        
        End With 
  
    ::oBrw262_CepsEnderecos:SetRDD()
    ::oBrw262_CepsEnderecos:CreateFromResource(262)
      
    aColunas[2]:SetOrder()
    ::oDt_CepEndereco:Gotop()
    ::oBrw262_CepsEnderecos:Gotop()

  Redefine Button id 251 of ::oDlgTst ; 
    Action ::oDlgTst:End()

  Activate Dialog ::oDlgTst Centered NoModal ;
    On init {Eval(oSelf:oBrw261_CepsCidades:bChange),;
             oSelf:oBrw261_CepsCidades:SetFocus()}
  
	::oDlgTst:bValid := {||::End()}
  

Return Nil