////////////////////////////////////////////////////////////////////////////////////////////////////
// Classe principal para manipular funes de RDDADS estilo oop (programao orientada ao objeto) //
// Qualquer alterao ou modificao encaminhe para Giovany Vecchi                                //
// Giovany Vecchi 18/12/2011 giovanyvecchi@yahoo.com.br / giovanyvecchi@gmail.com                 //
////////////////////////////////////////////////////////////////////////////////////////////////////

#IFNDEF __DOS__

   #include "fivewin.ch" 

#ELSE

   #include "hbclass.ch"

  #DEFINE  CRLF CHR(13)+CHR(10)

  #xtranslate MsgInfo(<cMsn>) => Alert( <cMsn> )
  #xtranslate MsgStop(<cMsn>) => Alert( <cMsn> )

   #xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  If( <uVar1> == nil, <uVar1> := <uVal1>, ) ;;
                [ If( <uVarN> == nil, <uVarN> := <uValN>, ); ]

#ENDIF

#define HKEY_CLASSES_ROOT        2147483648
#define HKEY_CURRENT_USER        2147483649
#define HKEY_LOCAL_MACHINE       2147483650
#define HKEY_USERS               2147483651
#define HKEY_PERFORMANCE_DATA    2147483652
#define HKEY_CURRENT_CONFIG      2147483653
#define HKEY_DYN_DATA            2147483654

#Define ADS_DYNAMIC_AOF           0
#Define ADS_RESOLVE_IMMEDIATE     1
#Define ADS_RESOLVE_DYNAMIC       2
#Define ADS_KEYSET_AOF            4
#Define ADS_FIXED_AOF             8

STATIC st_aCtrlAlias_Tabelas, st_aCtrlAlias_Monitor, St_SifraoMoeda
STATIC St_nRecnoNew
STATIC st_lProcessAutoAlias

CLASS TAds

  DATA nOpenType, nOpenStatus, cOpenStatus, nOpenAliasCtrl, nConnectionType
  DATA aStructTads, aBuffersField
  DATA cAlias, cTableAliasTmp, cTableName
  DATA lBof, lEof
  DATA cFilterMask, aVarsFormat
  DATA nFocusRecno, nRecnoLastInsert, nRecnoLastAppend, nRecnoVarPutSet
  DATA cOrderFocus
  Data aFilterFix
  Data aArrayRecnos, nFieldsCount, nRecnoArrayAtual, nPosArrayRecnoAtual, nSecondsArrayRecnoRefresh
  Data lArrayBuffer AS LOGIC INIT .F.
 
  METHOD NewRdd(f_cTableName,f_nConexao,f_nCache, f_lExclusive)

  METHOD End()

  Method FieldInfo(f_cCampo) // Retorna vetor com dados da estrutura do campo
  Method FieldPos(f_cCampo) // Retorna a Posio do campo na tabela
  Method FieldBlank(f_cCampo) // Retorna as caracteristica do campo em branco

  METHOD Lock(f_nRecno)
  METHOD RLock(f_nRecno)
  METHOD UnLock(f_nRecno)
  METHOD IsRecordLocked(f_nRecno)

  METHOD OnSkip()
  METHOD Skip(f_nSkip)
  METHOD GoTop()
  METHOD GoBottom()
  METHOD GoTo(f_nRecno)
  METHOD Bof() INLINE (::cAlias)->(Bof())
  METHOD Eof() INLINE (::cAlias)->(Eof())
  METHOD LastRec() INLINE (::cAlias)->(LastRec())
  Method KeyCount(f_nModo)

  METHOD Append()
  METHOD Delete(f_lLock)

  METHOD Refresh()

  METHOD VarGet(f_cCampo)
  Method VarGetFieldNull(f_cCampo) // Retorna valor do campo vazio
  METHOD VarGetAlltrim(f_cCampo) // Le o campo tipo caracter e limpa os brancos de ambos os lados
  METHOD VarGetRtrim(f_cCampo) // Le o campo tipo caracter e limpa os brancos a direita
  METHOD VarGetStrZero(f_cCampo,f_nZeros) // Le o campo tipo numerico e preenche com zeros
  Method VarGetDivZero(f_cCampo) // Nunca retorna 0 Zero
  METHOD VarGetTransform(f_cCampo,f_cMask) // Le o campo tipo numerico e formata
  Method VarGetSubStr(f_cCampo,f_nCharStart, f_nCharCount) //Retorna uma parte do conteudo do campo caracter
  METHOD VarGetCleanChars(f_cCampo,f_aCharsClean) // Le o campo tipo caracter e apaga caracteres solicitados
  Method VarGetPadL(f_cCampo,nPadChar) // Le campo Numerico, Data ou Caracter e preenche com espacos a Esquerda
  Method VarGetPadR(f_cCampo,nPadChar) // Le campo Numerico, Data ou Caracter e preenche com espacos a Direita

  METHOD VarGetNumToChar(f_cCampo,f_nCasasDecimais,f_lFixCasasDecimais)
      // f_cCampo > Campo da tabela
      // f_nCasasDecimais >  Casas decimais a apresentar, Se f_lFixCasasDecimais for verdadeiro,
      //                mostrara zeros conforme o numero de casas decimais, seno
      //                sera suprido os zeros.
      //                Ex: 102.20 Varget("CAMPO",2,.T.) > Resulta 102,20
      //                Ex: 102.20 Varget("CAMPO",2,.F.) > Resulta 102,2
      // f_lFixCasasDecimais > Se  para fixar a quantidade da casas decimais / padro .F.

  METHOD VarGetDateToChar(f_cCampo,f_nTpConvert)
      // f_cCampo > Campo da tabela
      // f_nTpConvert >    Tipo de converso do campo data
      //              0-Converte para numeros ( 31/12/2010 ) padro
      //              1-Converte em extenso simples (31 de Dezembro de 2010)
      //              2-Converte em extenso completo ( Sexta feira, 31 de Dezembro de 2010 )

  METHOD VarGetYear(f_cCampoDt,f_lStrReturn)
      // f_cCampoDt > Campo da tabela do Tipo Date
      // f_lStrReturn >  Tipo de retorno da Variavel ( Padro .F.)
      //            .F. - Retorna Numerico Ex: 2012 / padro
      //            .T. - Retorna String Ex: "2012"

  METHOD VarGetNumToMoeda(f_cCampo,f_nCasasDecimais,f_lNulo,f_nEspacoPreenche,f_cCharEspaco,f_cSifrao)
      // f_cCampo > Campo da tabela
      // f_nCasasDecimais >  Quantidade de casas decimais / Padro 2
      //  f_lNulo >        Se o Valor for 0,00 retornar "" nulo
      //  f_nEspacoPreenche >  Preenche com espaos a frente para determinar sempre o mesmo tamanho
      //  f_cCharEspaco >    Caracter para preencher os espaos. / Padro " "
      // f_cSifrao >       Sigla do sifrao da moeda. / Padro R$

  METHOD VarGetNumToMoedaExtenso(f_cCampo,f_nTpConvert)
      // f_cCampo > Campo da tabela
      // f_nTpConvert >    Tipo de converso do campo numerico
      //              0-Converte em extenso simples (Cento e Dois Reais) PADRO
      //              1-Converte em extenso completo " R$ 102,00 (Cento e Dois Reais) "

  METHOD VarGetAtokens(f_cCampo,f_cCharSeparator)
   
  METHOD VarPut(f_cCampo,f_uVal,f_cOperador)
  METHOD VarPutDbfTmp(f_cCampo,f_cAliasDbf)

  METHOD Commit(f_lUnlock)

  METHOD SetOrder(f_uOrder)
  METHOD Seek(f_uOcorrencia,f_cTagOpcional,f_lAproximado,f_lReturnLastTag)
  Method Locate(f_cCampo,f_uValor)

  METHOD Recno()
  Method aGetRecnos()

  METHOD Scope(f_cTagIndex,f_uTopCondicao,f_uEofCondicao)
  METHOD Filter(f_cFilterMask,f_aVarsFormat,f_nTpFiltro)
  METHOD FilterFts(f_cCampo,f_aStrings)
  METHOD AddFilterFix(f_cFilterMask,f_aVarsFormat)
  Method AddRecnosInFilter(f_aRecnos)
  METHOD FilterRefresh()
  METHOD RefreshFilter()
  METHOD CommandFormat(f_cStrCommand,f_aVarsFormat,f_nOpenType)
  METHOD GetFilter() Inline (::cAlias)->(AdsGetAof())
  METHOD ClearFilter(f_lFilterFixRemove)
  Method IsRecordInFilter(f_nRecno)

  METHOD Blob2File(f_cFileDestino,f_cCampoNome)
  METHOD File2Blob(f_cFileOrigem,f_cCampoNome)

  /////////////////////////////////////////////////////////////////////////////
  /////// tDataSet

  Data oConexao, nQryTipo
  Data cQrySql, aVarsSql, cDsTxtAlias, cQrySqlLast
  Data nErrorSql
  Data lQrySelectStart
  Data lDsCursorsToTemp, lDsTempEraseOnClose
  Data lDsCursorsToArray, aDsCursorsData, aDsCursorsHeaders 
  Data aFieldsTempIndex

  METHOD DsNew( f_nQryTipo, f_nConexao ) 
      // f_nQryTipo   > Tipo da Query
      //                1-Quando h retorno de cursor ou handle EX: SELECT
      //                2-Sem retorno de tabela EX: INSERT, UPDATE, DELETE
      // f_nConexao   > Numero da Conexo - Default tAds_GetConnectionDefault() 
      
  METHOD DsExecute(f_nQuery)
  METHOD DsError(f_nErrorSql,f_cErrorSql,f_cSqlScript,f_cErrorComplete)
  METHOD DsCursorsToArray()
  METHOD DsCursorsToTemp()
  
  ///METHOD DataSetFillRecno()

ENDCLASS
//-----------------------------------------------------------------------------
METHOD NewRdd(f_cTableName,f_nConexao, f_nCache, f_lExclusive) Class TAds
  LOCAL cComando := "", nIFor := 0,;
      aTmpChar := {}, cTmpAliasName := "", nTmpAliasExistentePosition := 0, nTmpAliasNewPosition := 0

  DEFAULT f_nConexao := tAds_GetConnectionDefault(), f_nCache := nCacheAds(), f_lExclusive := .F.  ///360

  ::oConexao := tAds_GetConnectionObj(f_nConexao)
  
  ///AdsConnection(::oConexao:hConnectHandle)

  St_nRecnoNew := 0

  If Hb_IsNil(st_lProcessAutoAlias)
    st_lProcessAutoAlias := .F.
  EndIf
  Do While st_lProcessAutoAlias
    hb_idleSleep(0.1)
  EndDo

  st_lProcessAutoAlias := .T.

  If Hb_IsNil(St_SifraoMoeda)
    St_SifraoMoeda := "R$"
  EndIf

  if Hb_IsNil(st_aCtrlAlias_Tabelas)
    st_aCtrlAlias_Tabelas  := {}
    st_aCtrlAlias_Monitor  := {}
  EndIf

  ::nOpenAliasCtrl := 0
  ::cTableName := f_cTableName

  For nIfor := 1 to 999
    cTmpAliasName := SubStr(f_cTableName,1,7)+StrZero(nIFor,2)
    nTmpAliasExistentePosition := aScan(st_aCtrlAlias_Tabelas,cTmpAliasName)
    If nTmpAliasExistentePosition == 0
      Exit
    EndIf
  Next

  cTmpAliasName := cTmpAliasName

  nTmpAliasNewPosition := aScan(st_aCtrlAlias_Tabelas,"_EMPTY_")

  If nTmpAliasNewPosition == 0
    aadd(st_aCtrlAlias_Tabelas,cTmpAliasName)
    aadd(st_aCtrlAlias_Monitor,cTmpAliasName+" - "+ProcName(1)+" ("+AllTrim(Str(ProcLine(1)))+")")
    nTmpAliasNewPosition := aScan(st_aCtrlAlias_Tabelas,cTmpAliasName)
  Else
    st_aCtrlAlias_Tabelas[nTmpAliasNewPosition]  := cTmpAliasName
    st_aCtrlAlias_Monitor[nTmpAliasNewPosition]  := (cTmpAliasName+" - "+ProcName(1)+" ("+AllTrim(Str(ProcLine(1)))+")")
  EndIf

  ::nOpenAliasCtrl := nTmpAliasNewPosition

  st_lProcessAutoAlias := .F.

  ::nRecnoLastInsert   := 0
  ::nRecnoLastAppend   := 0
  ::nRecnoVarPutSet    := 0

  ::nOpenType        := 1 // RDD
  ::nOpenStatus      := 0
  ::cOpenStatus      := "0 - Alias do recurso de dados aberto com sucesso"
  ::cAlias           := cTmpAliasName
  ::aFilterFix       := {}
  ::aBuffersField    := {}

  IF !ADSCHECKEXISTENCE(f_cTableName,::oConexao:hConnectHandle)
     MSGSTOP("No foi encontrado a tabela "+f_cTableName+" "+;
             "na lista dos recursos do Data Dictionary para conexo."+CRLF+;
             "A inicializao ser finalizada.",;
             "Erro, Ausncia de Tabela...")
     ::nOpenStatus := 1
     ::cOpenStatus := "1 - Tabela no encontrada: "+f_cTableName
     RETURN Self
  ENDIF

 AdsConnection(::oConexao:hConnectHandle)

  If f_lExclusive
    USE (f_cTableName) ALIAS (cTmpAliasName) NEW EXCLUSIVE
    If NetErr()
      ::nOpenStatus := 3
      ::cOpenStatus := "3 - Erro acesso Exclusivo tabela: "+f_cTableName
      Return Self
    EndIf
  Else
    USE (f_cTableName) ALIAS (cTmpAliasName) NEW SHARED
    If NetErr()
      ::nOpenStatus := 2
      ::cOpenStatus := "2 - Erro abertura modo compartilhado tabela: "+f_cTableName
      Return Self
    EndIf
  EndIf
  
  If f_nCache > 0
    (cTmpAliasName)->(AdsCacheRecords(f_nCache))
  EndIf

  ::OnSkip()
  ::cOrderFocus       := ""
  ::aStructTads       := TAds_StructCreate(::cAlias)
  ::nConnectionType   := (::cAlias)->(AdsGetTableConType())

RETURN Self
//-----------------------------------------------------------------------------
METHOD End() Class TAds

  If ::nOpenType == 1
    (::cAlias)->(DbCommit())
    (::cAlias)->(AdsFlushFileBuffers())
    (::cAlias)->(DbrUnlock())
  EndIf
  
  If ::nOpenType == 1   // RDD
    (::cAlias)->(DbCloseArea())
  ElseIf ::nOpenType == 2 // sql select
    (::cAlias)->(DbCloseArea()) /// Obsoleto
  ElseIf ::nOpenType == 3 // Data Set Sql
    If ::nQryTipo == 1 // Select   
      If ::nErrorSql == 0
        (::cAlias)->(DbCloseArea())
      EndIf
    EndIf
    If ::lDsCursorsToTemp .and. !::lDsTempEraseOnClose
      TAds_TableErase(121,::cTableAliasTmp)
    EndIf
  EndIf
    
  If ::nOpenAliasCtrl > 0
    st_aCtrlAlias_Tabelas[::nOpenAliasCtrl]  := "_EMPTY_"
    st_aCtrlAlias_Monitor[::nOpenAliasCtrl]  := "_EMPTY_"
  EndIf

RETURN NIL
//-----------------------------------------------------------------------------
Method FieldInfo(f_cCampo) Class TAds
  Local aRetStruct := {"","C",1,0}, iFor := 0

  For Ifor := 1 To len(::aStructTads)
    If Upper(::aStructTads[iFor,1]) == Upper(f_cCampo)
      aRetStruct[1] := ::aStructTads[iFor,1]
      aRetStruct[2] := ::aStructTads[iFor,2]
      aRetStruct[3] := ::aStructTads[iFor,3]
      aRetStruct[4] := ::aStructTads[iFor,4]
    EndIf
  Next

Return aRetStruct
//-----------------------------------------------------------------------------
Method FieldPos(f_cCampo) Class TAds
  Local nPos := 1, iFor := 0

  For Ifor := 1 To len(::aStructTads)
    If Upper(::aStructTads[iFor,1]) == Upper(f_cCampo)
      nPos := iFor
      Exit
    EndIf
  Next

Return nPos
//-----------------------------------------------------------------------------
Method FieldBlank(f_cCampo) Class TAds
  Local uGet := Nil, nPosField := 0

  nPosField := (::cAlias)->(FieldPos(f_cCampo))

  uGet := (::cAlias)->(FieldGet(nPosField))

  If ValType(uGet) == "C"
    uGet := Space(::aStructTads[nPosField][3])
  Elseif ValType(uGet) == "N"
    uGet := 0
  Elseif ValType(uGet) == "I"
    uGet := 0
  Elseif ValType(uGet) == "D"
    uGet := cTod("  /  /    ")
  EndIf

Return uGet
//-----------------------------------------------------------------------------
METHOD OnSkip() Class TAds

  ::lBoF        := (::cAlias)->(Bof())
  ::lEoF        := (::cAlias)->(Eof())
  ::nFocusRecno := (::cAlias)->(Recno())

RETURN NIL
//-----------------------------------------------------------------------------
METHOD Lock(f_nRecno) Class TAds
  Local lLockRecno := .F., iForTentativa := 0

  Default f_nRecno := (::cAlias)->(Recno())

  If (::cAlias)->(Recno()) != f_nRecno
    (::cAlias)->(DbGoTo(f_nRecno))
    ::OnSkip()
  EndIf

  For iForTentativa := 1 To 5
    (::cAlias)->(AdsRefreshRecord())
    If (::cAlias)->(DbRLock())
      lLockRecno := .T.
      Exit
    Else
      SysWait(.2)
    EndIf
  Next

RETURN lLockRecno
//-----------------------------------------------------------------------------
METHOD RLock(f_nRecno) Class TAds
  Local lLockRecno := .F., iForTentativa := 0

  Default f_nRecno := (::cAlias)->(Recno())

  If (::cAlias)->(Recno()) != f_nRecno
    (::cAlias)->(DbGoTo(f_nRecno))
    ::OnSkip()
  EndIf

  For iForTentativa := 1 To 16
    (::cAlias)->(AdsRefreshRecord())
    If (::cAlias)->(DbRLock())
      lLockRecno := .T.
      Exit
    Else
      SysWait(.2)
    EndIf
  Next

RETURN lLockRecno
//-----------------------------------------------------------------------------
METHOD UnLock(f_nRecno) Class TAds
  Local lUnLockRecno := .F., iForTentativa := 0

  Default f_nRecno := (::cAlias)->(Recno())

  If (::cAlias)->(Recno()) != f_nRecno
    (::cAlias)->(DbGoTo(f_nRecno))
    ::OnSkip()
  EndIf

  (::cAlias)->(DbRUnLock())

  lUnLockRecno := .T.

RETURN lUnLockRecno
//-----------------------------------------------------------------------------
METHOD IsRecordLocked(f_nRecno) Class TAds
  Local lIsRecnoLocked := .F.

  Default f_nRecno := (::cAlias)->(Recno())

  If (::cAlias)->(Recno()) != f_nRecno
    (::cAlias)->(DbGoTo(f_nRecno))
    ::OnSkip()
  EndIf

  lIsRecnoLocked := (::cAlias)->(AdsIsRecordLocked())

RETURN lIsRecnoLocked
//-----------------------------------------------------------------------------
METHOD Skip(f_nSkip) Class TAds

  Default f_nSkip := 1

  (::cAlias)->(DbSkip(f_nSkip))

  ::OnSkip()

RETURN ::Recno()
//-----------------------------------------------------------------------------
METHOD GoTop() Class TAds

  (::cAlias)->(DbGoTop())
  ::OnSkip()

RETURN NIL
//-----------------------------------------------------------------------------
METHOD GoBottom() Class TAds

  (::cAlias)->(DbGoBottom())
  ::OnSkip()

RETURN NIL
//-----------------------------------------------------------------------------
METHOD GoTo(f_nRecno) Class TAds
  Local lOkRegistro := .T.

  if f_nRecno == 0
    f_nRecno := 1
  EndIf

  (::cAlias)->(DbGoTo(f_nRecno))
  If ::Eof()
    (::cAlias)->(AdsRefreshRecord())
    (::cAlias)->(LastRec())
    (::cAlias)->(AdsRefreshRecord())
  EndIf
  If ::Recno() != f_nRecno
    lOkRegistro := .F.
  EndIf
  ::OnSkip()

RETURN lOkRegistro
//-----------------------------------------------------------------------------
METHOD Append() Class TAds
  Local lAppend := .F.

  ::nRecnoLastAppend := 0
  lAppend := (::cAlias)->(DbAppend())
  ::nRecnoLastAppend := ::Recno()
  ::OnSkip()
  St_nRecnoNew := ::nRecnoLastAppend

RETURN lAppend
//-----------------------------------------------------------------------------
METHOD Delete(f_lLock) Class TAds
  Local lDelete := .F.

  Default f_lLock := .F.

  If f_lLock
    If !::rLock()
      Return .F.
    EndIf
  EndIf

  lDelete := (::cAlias)->(DbDelete())

RETURN lDelete
//-----------------------------------------------------------------------------
METHOD Refresh() Class TAds

  (::cAlias)->(AdsRefreshRecord())

RETURN Nil
//-----------------------------------------------------------------------------
Method KeyCount(f_nModo)
  Local nRecCount := 0

  Default f_nModo := 1  // 1-Respeita filtros e condies 2-Calcula o indice inteiro

  nRecCount := (::cAlias)->(ADSKeyCount(,,f_nModo))

Return nRecCount
//-----------------------------------------------------------------------------
METHOD VarGet(f_cCampo,f_lRefresh) Class TAds
  Local uGet := Nil, nPosField := 1, iForField := 0, nRecnoAtual := 0

  Default f_lRefresh := .F.

  uGet := (::cAlias)->(FieldGet(::FieldPos(f_cCampo)))

  If Hb_IsNil(uGet)
    uGet := (::cAlias)->&f_cCampo
  EndIf

RETURN uGet
//-----------------------------------------------------------------------------
Method VarGetFieldNull(f_cCampo) Class TAds
  Local uGet := Nil, nPosField := 0

  nPosField := (::cAlias)->(FieldPos(f_cCampo))

  uGet := (::cAlias)->(FieldGet(nPosField))

  If ValType(uGet) == "C"
    uGet := Space(::aStructTads[nPosField][3])
  Elseif ValType(uGet) == "N"
    uGet := 0
  Elseif ValType(uGet) == "D"
    uGet := cTod("  /  /    ")
  EndIf

Return uGet
//-----------------------------------------------------------------------------
METHOD VarGetAlltrim(f_cCampo) Class TAds
  Local uGet := Nil

  uGet := Alltrim(::VarGet(f_cCampo))

RETURN uGet
//-----------------------------------------------------------------------------
METHOD VarGetRtrim(f_cCampo) Class TAds
  Local uGet := Nil

  uGet := RTrim(::VarGet(f_cCampo))

RETURN uGet
//-----------------------------------------------------------------------------
METHOD VarGetDivZero(f_cCampo) Class TAds
  Local nGet := 0

  nGet := ::VarGet(f_cCampo)

  If nGet == 0
    nGet := 1
  EndIf

RETURN nGet
//-----------------------------------------------------------------------------
METHOD VarGetStrZero(f_cCampo,f_nZeros) Class TAds
  Local uGet := Nil

  Default f_nZeros := 9

  uGet := StrZero(::VarGet(f_cCampo),f_nZeros)

RETURN uGet
//-----------------------------------------------------------------------------
METHOD VarGetTransform(f_cCampo,f_cMask) Class TAds
  Local uGet := Nil

  Default f_cMask := "@!"

  uGet := Transform(::VarGet(f_cCampo),f_cMask)

RETURN uGet
//-----------------------------------------------------------------------------
Method VarGetSubStr(f_cCampo,f_nCharStart,f_nCharCount)
  Local cRet := ""

  Default f_nCharStart := 1

  cRet := SubStr(::VarGet(f_cCampo),f_nCharStart,f_nCharCount)

Return cRet
//-----------------------------------------------------------------------------
METHOD VarGetCleanChars(f_cCampo,f_aCharsClean) Class TAds
  Local cGet := ""

  Default f_aCharsClean := {" "}

  cGet := TAds_CleanChars(::VarGet(f_cCampo),f_aCharsClean)

RETURN cGet
//-----------------------------------------------------------------------------
Method VarGetPadL(f_cCampo,nPadChar) Class TAds
  Local cValType := "", uGet := ::VarGet(f_cCampo)

  cValType := ValType(uGet)

  If cValType == "N"
    uGet := Alltrim(Str(uGet))
  ElseIf cValType == "I"
    uGet := Alltrim(Str(uGet))
  ElseIf cValType == "D"
    uGet := cToD(uGet)
  EndIf

  uGet := PadL(Alltrim(uGet),nPadChar)

Return uGet
//-----------------------------------------------------------------------------
Method VarGetPadR(f_cCampo,nPadChar) Class TAds
  Local cValType := "", uGet := ::VarGet(f_cCampo)

  cValType := ValType(uGet)

  If cValType == "N"
    uGet := Alltrim(Str(uGet))
  ElseIf cValType == "I"
    uGet := Alltrim(Str(uGet))
  ElseIf cValType == "D"
    uGet := cToD(uGet)
  EndIf

  uGet := PadR(Alltrim(uGet),nPadChar)

Return uGet
//-----------------------------------------------------------------------------
METHOD VarGetNumToChar(f_cCampo,f_nCasasDecimais,f_lFixCasasDecimais) Class TAds
  Local cRetVal := ""

  Default f_nCasasDecimais := 2, f_lFixCasasDecimais := .F.

  cRetVal := TAds_Str(::VarGet(f_cCampo),0,!f_lFixCasasDecimais,f_nCasasDecimais,.T.)

RETURN cRetVal
//-----------------------------------------------------------------------------
METHOD VarGetDateToChar(f_cCampo,f_nTpConvert) Class TAds
  Local cRetVal := ""

  Default f_nTpConvert := 0

  If f_nTpConvert == 0
    cRetVal := DtoC(::VarGet(f_cCampo))
  Elseif f_nTpConvert == 1
    cRetVal := TAds_DataExtenso(::VarGet(f_cCampo),.F.)
  ElseIf f_nTpConvert == 2
    cRetVal := TAds_DataExtenso(::VarGet(f_cCampo),.T.)
  EndIf

RETURN cRetVal
//-----------------------------------------------------------------------------
METHOD VarGetYear(f_cCampoDt,f_lStrReturn)
  Local uRetVal

  If Hb_IsNil(f_lStrReturn)
    f_lStrReturn := .F.
  EndIf

  If f_lStrReturn
    uRetVal := TAds_Str(Year(::VarGet(f_cCampoDt)))
  Else
    uRetVal := Year(::VarGet(f_cCampoDt))
  EndIf

Return uRetVal
//-----------------------------------------------------------------------------
METHOD VarGetNumToMoeda(f_cCampo,f_nCasasDecimais,f_lNulo,f_nEspacoPreenche,f_cCharEspaco,f_cSifrao) class TAds
  Local cRetVal

  Default f_nCasasDecimais := 2, f_lNulo := .T., f_nEspacoPreenche := 0, f_cCharEspaco := " "

  cRetVal := TAds_Valor(::VarGet(f_cCampo),f_nCasasDecimais,f_lNulo,f_nEspacoPreenche,f_cCharEspaco,.T.)

RETURN cRetVal
//-----------------------------------------------------------------------------
METHOD VarGetNumToMoedaExtenso(f_cCampo,f_nTpConvert) Class TAds
  Local cRetVal := ""

  Default f_nTpConvert := 0

  If f_nTpConvert == 0
    cRetVal := TAds_ValExtenso(::VarGet(f_cCampo),.F.)
  ElseIf f_nTpConvert == 1
    cRetVal := TAds_ValExtenso(::VarGet(f_cCampo),.T.)
  EndIf

RETURN cRetVal
//-----------------------------------------------------------------------------
METHOD VarGetAtokens(f_cCampo,f_cCharSeparator) Class TAds
  Local aTokens := {}

  Default f_cCharSeparator := " "
  
  aTokens := Hb_aTokens(::VarGet(f_cCampo),f_cCharSeparator,.T.)

Return aTokens
//-----------------------------------------------------------------------------
METHOD VarPut(f_cCampo,f_uVal,f_cOperador) Class TAds
  Local uField := ""

  Default f_cOperador := "="

  If ValType(f_uVal) == "C"
    f_uVal := StrTran(f_uVal,"'","") // Muitos erros ocorrem em instrues sql por causa deste caracter
  EndIf

  If f_cOperador == "="
    (::cAlias)->&f_cCampo := (f_uVal)
  ElseIf f_cOperador == "+"
    ::Refresh()
    (::cAlias)->&f_cCampo += (f_uVal)
  ElseIf f_cOperador == "-"
    ::Refresh()
    (::cAlias)->&f_cCampo -= (f_uVal)
  Else
    (::cAlias)->&f_cCampo := (f_uVal)
  EndIf

RETURN Nil
//-----------------------------------------------------------------------------
METHOD VarPutDbfTmp(f_cFieldNameAdt,f_cAliasDbf) Class TAds  // oBsoleto
  Local cFieldNameDbf := ""

  ///cFieldNameDbf := TAds_FieldAdtToDbf(f_cFieldNameAdt)

  ::VarPut(f_cFieldNameAdt,(f_cAliasDbf)->&cFieldNameDbf)

RETURN Nil
//-----------------------------------------------------------------------------
METHOD Commit(f_lUnlock) Class TAds

  Default f_lUnlock := .F.

  If f_lUnlock
    (::cAlias)->(DbrUnlock())
  EndIf

  (::cAlias)->(DbCommit())
  If ::nConnectionType == 1 // Local Connection
    (::cAlias)->(AdsFlushFileBuffers())
  EndIf
  (::cAlias)->(DbCommit())
  ::Refresh()

RETURN Nil
//-----------------------------------------------------------------------------
METHOD SetOrder(f_uOrder) Class TAds
  Local cOrder := ""

  If ValType(f_uOrder) == "C"
    cOrder := Upper(f_uOrder)
  Else
    cOrder := (::cAlias)->(OrdName(f_uOrder))
  EndIf

  If GetKeyState("VK_SHIFT")
      //? cOrder
  EndIf
  If ::cOrderFocus != cOrder
    (::cAlias)->(OrdSetFocus(cOrder))
    (::cAlias)->(DbSetOrder(cOrder))
    ::cOrderFocus := (::cAlias)->(OrdName(0))
  EndIf

RETURN NIL
//-----------------------------------------------------------------------------
METHOD Seek(f_uOcorrencia,f_cTagOpcional,f_lAproximado,f_lReturnLastTag) Class TAds
  Local lFoundOcorrencia := .F., cLastTag := ::cOrderFocus

  Default f_lAproximado := .F., f_lReturnLastTag := .F.

  If !Hb_IsNil(f_cTagOpcional)
    ::SetOrder(f_cTagOpcional)
  EndIf

  lFoundOcorrencia := (::cAlias)->(DbSeek(f_uOcorrencia,f_lAproximado))
  
  if !lFoundOcorrencia .and. !::Eof()
    If !f_lAproximado
      If !Empty(::cOrderFocus)
        lFoundOcorrencia := (f_uOcorrencia == ::VarGet(::cOrderFocus))
      EndIf
    Else
      lFoundOcorrencia := .T.  
    EndIf
  EndIf
  If f_lReturnLastTag 
    If !Empty(cLastTag)
      ::SetOrder(cLastTag)
    EndIf
  EndIf
  ::OnSkip()

RETURN lFoundOcorrencia
//-----------------------------------------------------------------------------
Method Locate(f_cCampo,f_uValor) Class TAds
  Local lFoundRegistro := .F., nRecAtual := ::Recno()

  ::GoTop()
  Do While !::Eof()
    If ::VarGet(f_cCampo) == f_uValor
      lFoundRegistro := .T.
      Exit
    EndIf
    ::Skip()
  EndDo

  If !lFoundRegistro
    ::GoTo(nRecAtual)
  Else
    ::OnSkip()
  EndIf

Return lFoundRegistro
//-----------------------------------------------------------------------------
METHOD Recno() Class TAds
  Local nRecno := 0

  If (::cAlias)->(Eof())
    Return 0
  EndIf

  nRecno := (::cAlias)->(Recno())

RETURN nRecno
//-----------------------------------------------------------------------------
METHOD aGetRecnos() Class TAds
  Local aRecnos := {}, nRecatual := ::Recno()

  ::GoTop()
  Do While !::Eof()
    AaDd(aRecnos,::Recno())
    ::Skip()
  Enddo

  If nRecAtual > 0
    ::GoTo(nRecatual)
  EndIf

Return aRecnos
//-----------------------------------------------------------------------------
METHOD Scope(f_cTagIndex,f_uTopCondicao,f_uEofCondicao) Class TAds

 default f_uEofCondicao := f_uTopCondicao 
 
 ::SetOrder(f_cTagIndex)
 (::cAlias)->(OrdScope(0,f_uTopCondicao))
 (::cAlias)->(OrdScope(1,f_uEofCondicao))
 ::GoTop()                                

Return Nil
//-----------------------------------------------------------------------------
METHOD Filter(f_cFilterMask,f_aVarsFormat,f_nTpFiltro) class TAds
  Local _nRecMarca:=(::cAlias)->(RECNO())
  Local _lFiltro:=.F., iForFilter := 0, cAnd := "", cTpAnd := " .and. "

  Default   f_nTpFiltro := 1,;
        f_cFilterMask := ""

  If ::nOpenType == 1 // RDD
    cTpAnd := " .and. "
  ElseIf ::nOpenType == 2 // SQL
    cTpAnd := " and "
  EndIf

  IF !Hb_IsNil(f_AVarsFormat)
     f_cFilterMask := ::CommandFormat(f_cFilterMask,f_aVarsFormat,::nOpenType)
  ENDIF

  If !Empty(f_cFilterMask)
    cAnd := cTpAnd
  EndIf

  For iForFilter := 1 to Len(::aFilterFix)
    f_cFilterMask += cAnd + ::aFilterFix[iForFilter]
    cAnd := cTpAnd
  Next

  If Empty(f_cFilterMask)
    (::cAlias)->(AdsClearAof())
    Return .F.
  EndIf

  IF Ascan({  ADS_DYNAMIC_AOF,;
          ADS_RESOLVE_IMMEDIATE,;
          ADS_RESOLVE_DYNAMIC,;
          ADS_RESOLVE_IMMEDIATE + ADS_KEYSET_AOF,;
          ADS_RESOLVE_DYNAMIC + ADS_KEYSET_AOF,;
          ADS_RESOLVE_IMMEDIATE + ADS_FIXED_AOF,;
          ADS_RESOLVE_DYNAMIC + ADS_FIXED_AOF},f_nTpFiltro) == 0
     f_nTpFiltro := 1
  ENDIF

  IF LEN((::cAlias)->(AdsGetAof())) > 0
     (::cAlias)->(AdsClearAof())
     (::cAlias)->(DBGOTOP())
  ENDIF

  IF f_cFilterMask != Nil

     _lFiltro := (::cAlias)->(AdsSetAof(f_cFilterMask,f_nTpFiltro))

     IF _lFiltro
        ::GoTop()
     ENDIF

  ENDIF

  ::OnSkip()

RETURN _lFiltro

//-----------------------------------------------------------------------------
METHOD FilterFts(f_cCampo,f_aStrings) class TAds
  Local _nRecMarca:=(::cAlias)->(RECNO())
  Local _lFiltro := .F., iForFilter := 0, cAnd := "( ", cStrings := "", cFilterFix := ""

  /// AND, OR, NOT, and NEAR

  cStrings := "CONTAINS("+f_cCampo+",'"
  For iForFilter := 1 To Len(f_aStrings)
    cStrings += f_aStrings[iForFilter,1]+" "+f_aStrings[iForFilter,2]+" "
  Next
  cStrings += "' )"

  For iForFilter := 1 to Len(::aFilterFix)
    cFilterFix += cAnd + ::aFilterFix[iForFilter]
    cAnd := " And "
  Next
  If !Empty(cFilterFix)
    cFilterFix += " ) And "
  EndIf

  IF LEN((::cAlias)->(AdsGetAof())) > 0
     (::cAlias)->(AdsClearAof())
     (::cAlias)->(DBGOTOP())
  ENDIF

   _lFiltro := (::cAlias)->(AdsSetAof(cFilterFix+cStrings,1))

   IF _lFiltro
      ::GoTop()
   ENDIF

Return _lFiltro
//-----------------------------------------------------------------------------
METHOD AddFilterFix(f_cFilterMask,f_aVarsFormat) class TAds
  Local _nRecMarca:=(::cAlias)->(RECNO())
  Local _lFiltro:=.F., nTpFiltro := 1

  Default   nTpFiltro := 1,; 
            f_cFilterMask := ""

  IF f_AVarsFormat != Nil
     f_cFilterMask := ::CommandFormat(f_cFilterMask,f_aVarsFormat,::nOpenType)
  ENDIF

  IF f_cFilterMask != Nil
     f_cFilterMask  :=  StrTran(f_cFilterMask,"[","CTOD("+CHR(39))
     f_cFilterMask  :=  StrTran(f_cFilterMask,"]",CHR(39)+")")
     aadd(::aFilterFix,f_cFilterMask)
  ENDIF

RETURN Len(::aFilterFix)
//-----------------------------------------------------------------------------
METHOD AddRecnosInFilter(f_aRecnos) class TAds
  Local lOk := .T., iFor := 0, cRecnos := ""

  If !Empty(::GetFilter())
      (::cAlias)->(ADSCustomizeAOF(f_aRecnos))
  Else
    lOk := .F.
  EndIf
  ::OnSkip()

Return lOk
//-----------------------------------------------------------------------------
METHOD FilterRefresh() class TAds

  (::cAlias)->(AdsRefreshAof())
  ::Refresh()
  ::OnSkip()

Return Nil
//-----------------------------------------------------------------------------
METHOD RefreshFilter() class TAds

  If !Empty((::cAlias)->(AdsGetAof()))
    (::cAlias)->(AdsRefreshAof())
    ::OnSkip()
  EndIf
  ::Refresh()

Return Nil
//-----------------------------------------------------------------------------
Method ClearFilter(f_lFilterFixRemove) Class TAds

  Default f_lFilterFixRemove := .F.

  (::cAlias)->(AdsClearAof())

  If f_lFilterFixRemove
    ::aFilterFix := {}
  EndIf

  If Len(::aFilterFix) > 0
    ::Filter()
    ::OnSkip()
  EndIf

Return Nil
//-----------------------------------------------------------------------------
Method IsRecordInFilter(f_nRecno) Class TAds
  Local lPresent := .F.

  Default f_nRecno := ::Recno()

  lPresent := (::cAlias)->(AdsIsRecordInAof(f_nRecno))

Return lPresent
//-----------------------------------------------------------------------------
METHOD CommandFormat(f_cStrCommand,f_aVarsFormat,f_nOpenType) class TAds
  Local _cRet := f_cStrCommand, _iFor := 0, _cTmpVar := "", _cTmpFormat := "", _cTmpData := ""

  Default f_nOpenType := ::nOpenType

  IF f_aVarsFormat == Nil
     Return _cRet
  ENDIF

  IF VALTYPE(f_aVarsFormat) != "A"
     Return _cRet
  ENDIF

  IF LEN(f_aVarsFormat) == 0
     Return _cRet
  ENDIF

  FOR _iFor := 1 TO LEN(f_aVarsFormat)
    _cTmpVar := f_aVarsFormat[_iFor,1]
    IF VALTYPE(f_aVarsFormat[_iFor,2]) == "C"

      _cTmpFormat := StrTran(f_aVarsFormat[_iFor,2],"'","")
      _cTmpFormat := "'"+_cTmpFormat+"'"

    ELSEIF VALTYPE(f_aVarsFormat[_iFor,2]) == "D"

      If f_nOpenType == 3 // Query Open Table In SELECT
        _cTmpData := DTOS(f_aVarsFormat[_iFor,2])
        _cTmpData := (SubStr(_cTmpData,1,4)+"-"+SubStr(_cTmpData,5,2)+"-"+SubStr(_cTmpData,7,2))
        _cTmpFormat := "'"+_cTmpData+"'"
      ElseIf f_nOpenType == 2 .or. f_nOpenType == 1 // SetAof Table open SQL or RDD
        _cTmpFormat := "'"+DTOC(f_aVarsFormat[_iFor,2])+"'"
        _cTmpFormat := "CTOD("+_cTmpFormat+")"
      EndIf

    ELSEIF VALTYPE(f_aVarsFormat[_iFor,2]) == "N"

      _cTmpFormat := ALLTRIM(STR(f_aVarsFormat[_iFor,2]))

    ELSEIF VALTYPE(f_aVarsFormat[_iFor,2]) == "L"

      If f_nOpenType == 3 // Query em Select
        _cTmpFormat := IF(f_aVarsFormat[_iFor,2],"TRUE","FALSE")
      ElseIf f_nOpenType == 2 .OR. f_nOpenType == 1 // Se for para Rdd
        _cTmpFormat := IF(f_aVarsFormat[_iFor,2],".T.",".F.")
      EndIf

    ENDIF
    _cRet := STRTRAN(_cRet,_cTmpVar,_cTmpFormat)
  NEXT

RETURN _cRet
//-----------------------------------------------------------------------------
METHOD Blob2File(f_cFileDestino,f_cCampoNome) Class TAds

  (::cAlias)->(AdsBlob2File(f_cFileDestino,f_cCampoNome))

RETURN NIL
//-----------------------------------------------------------------------------
METHOD File2Blob(f_cFileOrigem,f_cCampoNome) Class TAds

  (::cAlias)->(AdsFile2Blob(f_cFileOrigem,f_cCampoNome))

RETURN NIL
//-----------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
METHOD DsNew( f_nQryTipo, f_nConexao ) Class TAds
  LOCAL cComando := "", nIFor := 0
  LOCAL  cNewAlias := "", aTmpChar := {}, cTmpAliasName := "", nTmpAliasExistentePosition := 0, nTmpAliasNewPosition := 0

  Default f_nConexao := tAds_GetConnectionDefault(), f_nQryTipo := 0
  
  ::oConexao            := tAds_GetConnectionObj(f_nConexao)
  ::nQryTipo            := f_nQryTipo
  ::lDsCursorsToTemp    := .F.
  ::lDsCursorsToArray   := .F.
  ::aDsCursorsHeaders   := {}
  ::aDsCursorsData      := {}
  ::aFieldsTempIndex    := {}
  ::lDsTempEraseOnClose := .F.
  ::nErrorSql           := 0
  
  St_nRecnoNew := 0

  If Hb_IsNil(st_lProcessAutoAlias)
    st_lProcessAutoAlias := .F.
  EndIf
  Do While st_lProcessAutoAlias
    hb_idleSleep(0.1)
  EndDo
  st_lProcessAutoAlias := .T.

  If Hb_IsNil(St_SifraoMoeda)
    St_SifraoMoeda := "R$"
  EndIf

  if Hb_IsNil(st_aCtrlAlias_Tabelas)
    st_aCtrlAlias_Tabelas  := {}
    st_aCtrlAlias_Monitor  := {}
  EndIf

  Do While .T. 
    cTmpAliasName := "Sql_"+StrZero(nRandom(99991)+1,5)
    nTmpAliasExistentePosition := aScan(st_aCtrlAlias_Tabelas,cTmpAliasName)
    If nTmpAliasExistentePosition == 0
      Exit
    EndIf
  EndDo 

  ::cTableName      := "DataSet"
  ::cDsTxtAlias     := cTmpAliasName
  ::aVarsSql        := {}
  ::cQrySql         := ""
  ::cQrySqlLast     := ""
  ::nOpenAliasCtrl  := 0
  ::lQrySelectStart := .F.

  cNewAlias := cTmpAliasName

  nTmpAliasNewPosition := aScan(st_aCtrlAlias_Tabelas,"_EMPTY_")

  If nTmpAliasNewPosition == 0
    aadd(st_aCtrlAlias_Tabelas,cNewAlias)
    aadd(st_aCtrlAlias_Monitor,cNewAlias+" - "+ProcName(1)+" ("+AllTrim(Str(ProcLine(1)))+")")
    nTmpAliasNewPosition := aScan(st_aCtrlAlias_Tabelas,cNewAlias)
  Else
    st_aCtrlAlias_Tabelas[nTmpAliasNewPosition] := cNewAlias
    st_aCtrlAlias_Monitor[nTmpAliasNewPosition] := (cNewAlias+" - "+ProcName(1)+" ("+AllTrim(Str(ProcLine(1)))+")")
  EndIf

  ::nOpenAliasCtrl := nTmpAliasNewPosition

  st_lProcessAutoAlias := .F.

  ::nRecnoLastInsert  := 0
  ::nRecnoLastAppend  := 0
  ::nRecnoVarPutSet   := 0

  ::nOpenType     := 3 // SQL Data Set
  ::nOpenStatus   := 0
  ::cOpenStatus   := "0 - Tabela aberta com sucesso"
  ::cAlias        := cNewAlias
  ::aFilterFix    := {}
  ::aBuffersField := {}

RETURN Self
//-----------------------------------------------------------------------------
METHOD DsExecute(f_nCache) Class TAds
  Local cQueryTmp := "", iFor := 0, cTypeData := "C"
  Local aVarsFormatTmp := {}, _cTmpFormat := "", _cTmpData, uResult
  Local cTmp01, aErrorAds := {}, aErrorLog := {}, cErrorBuffer := "", cErrorFile := "", nErroLoop := 1
  Local lExeSucesso := .F.
  
  Default f_nCache := nCacheAds()

  cQueryTmp       := ::cQrySql
  aVarsFormatTmp  := ::aVarsSql  

  If ::nQryTipo == 0 // Verificar tipo da query
    If At(Upper(cQueryTmp),"SELECT") > 0 .and. At(Upper(cQueryTmp),"SELECT") < 10
      ::nQryTipo := 1 // Cursor Ativo
    Else
      ::nQryTipo := 2 // Query Insert / Update /create /Execute etc
    EndIf
  EndIf

  For iFor := 1 to Len(aVarsFormatTmp)

    cTypeData := ValType(aVarsFormatTmp[iFor,2])

    If cTypeData == "B"
      uResult   := Eval(aVarsFormatTmp[iFor,2])
      cTypeData := ValType(uResult)
    Else
      uResult := (aVarsFormatTmp[iFor,2])
    EndIf

    If cTypeData == "C"

      uResult := StrTran(uResult,::cDsTxtAlias,::cAlias)
      _cTmpFormat := StrTran(uResult,"'","")
      _cTmpFormat := "'"+_cTmpFormat+"'"

    ElseIf cTypeData == "D"

      _cTmpData := DTOS(uResult)
      _cTmpData := (SubStr(_cTmpData,1,4)+"-"+SubStr(_cTmpData,5,2)+"-"+SubStr(_cTmpData,7,2))
      _cTmpFormat := "'"+_cTmpData+"'"

    ElseIf cTypeData == "N"

      _cTmpFormat := ALLTRIM(STR(uResult))

    ElseIf cTypeData == "L"

      _cTmpFormat := IF(uResult,"TRUE","FALSE")

    ENDIF

    cQueryTmp := STRTRAN(cQueryTmp,aVarsFormatTmp[iFor,1],_cTmpFormat)

  Next

  If ::nQryTipo == 1 .and. ::lQrySelectStart  

    (::cAlias)->(DbCloseArea())
    
  EndIf

  ::cQrySqlLast := cQueryTmp
  
  Select 0
  AdsCreateSqlStatement(::cAlias,3,::oConexao:hConnectHandle)
  
  (::cAlias)->(AdsPrepareSQL(cQueryTmp))
  lExeSucesso := (::cAlias)->(AdsExecuteSQL())
  
  If !lExeSucesso
    ::nErrorSql := AdsGetLastError(@cErrorBuffer)
  EndIf
  
  IF ::nErrorSql <> 0
    aadd(aErrorLog,::nErrorSql)
    aadd(aErrorLog,cQueryTmp)
    aadd(aErrorLog,cErrorBuffer)    
    cErrorFile := cErrorBuffer +CRLF
    cErrorFile += Replicate("_",80)+CRLF
    cErrorFile += cQueryTmp+CRLF
    cErrorFile += Replicate("_",80)+CRLF

    while ( nErroLoop < 74 )
      if ! Empty(ProcName( nErroLoop ) )
        cErrorFile += "Called from: " + ProcFile( nErroLoop ) + " => " + Trim( ProcName( nErroLoop ) ) + ;
                        "(" + Alltrim(Str( ProcLine( nErroLoop ))) + ")" + CRLF 
      endif
      nErroLoop++
    end
    
    MemoWrit("SqlError.log",cErrorFile)
    
    If ::nQryTipo == 2
      (::cAlias)->(DbCloseArea())
    Endif
    
    MsgInfo(cErrorFile,"Sql Error "+AllTrim(Str(::nErrorSql)))

    ::DsError(::nErrorSql,cErrorBuffer,cQueryTmp,cErrorFile)

    ::End()
    
    Return lExeSucesso 
    
  ENDIF

  If ::nQryTipo == 1 // Cursor ativo

    (::cAlias)->(AdsCacheRecords(f_nCache))

    If !::lQrySelectStart 
      ::OnSkip()
      ::cOrderFocus     := ""
      ::aStructTads     := TAds_StructCreate(::cAlias)
      ::nConnectionType := (::cAlias)->(AdsGetTableConType())
      ::aArrayRecnos    := {}
      ::nFieldsCount    := Len(::aStructTads)
      ::lQrySelectStart := .T.
    EndIf

    If ::lDsCursorsToArray .and. !::lDsCursorsToTemp
      ::DsCursorsToArray()
    EndIf

    If ::lDsCursorsToTemp 
      ::DsCursorsToTemp()
    EndIf

  ElseIf ::nQryTipo == 2 // Insert, Update / no cursors

    ::End()

  EndIf

RETURN lExeSucesso
//-----------------------------------------------------------------------------
METHOD DsCursorsToArray() Class TAds
  Local iFor := 0, aTmpRegister := {}
  
  ::aDsCursorsHeaders := {}
  ::aDsCursorsData    := {}
  
  For Ifor := 1 To Len(::aStructTads)
    aadd(::aDsCursorsHeaders,::aStructTads[iFor,1])
  Next
 
  ::GoTop()
  Do While !::Eof()
    aTmpRegister := {}
    For Ifor := 1 To Len(::aStructTads)
      aadd(aTmpRegister,(::cAlias)->(FieldGet(iFor)))
    Next
    aadd(::aDsCursorsData,aTmpRegister)
    ::Skip()
  Enddo
  ::GoTop()
  
Return Nil
//-----------------------------------------------------------------------------
METHOD DsCursorsToTemp() Class TAds
  Local iFor := 0, iForField := 0, uGet := {}, aFieldStruct := {}
  Local cTmp := "", nTmp := 0
  
  For Ifor := 1 To Len(::aStructTads)
    aadd(::aDsCursorsHeaders,::aStructTads[iFor,1])
  Next

  ::cTableAliasTmp := StrTran(::cAlias,"Sql","Tmp")

  For iFor := 1 To Len(::aStructTads)
    aFieldStruct := ::aStructTads[iFor]
    If aFieldStruct[2] == "AutoIncrement"
      ::aStructTads[iFor,2] := "N"
      ::aStructTads[iFor,3] := 10
      ::aStructTads[iFor,4] := 0
    EndIf
    cTmp := aFieldStruct[1]
    If Ascan(::aFieldsTempIndex, cTmp) > 0
      ::aStructTads[iFor,5] := 1
    EndIf  
  Next
  
  ::GoTop()
  
  If AdsCheckExistence(::cTableAliasTmp,tAds_GetConnectionHandle(121))
    TAds_TableErase(121,::cTableAliasTmp)
  EndIf
  
  TAds_CreateTableFromCode(121,::cTableAliasTmp,::aStructTads)

  Select 0
  AdsCreateSqlStatement(::cTableAliasTmp,3,121)
  
  AdsConnection(tAds_GetConnectionHandle(121))
  
  USE (::cTableAliasTmp) ALIAS (::cTableAliasTmp) NEW EXCLUSIVE
  
  ///(::cAlias)->(AdsCopyTableContents(::cTableAliasTmp))

  ::DsCursorsToArray() // Carregar cursores para ::aDsCursorsData
  
  For iFor := 1 To Len(::aDsCursorsData)
    (::cTableAliasTmp)->(DbAppend()) 
    For iForField := 1 To Len(::aStructTads)
      (::cTableAliasTmp)->(FieldPut(iForField,::aDsCursorsData[iFor,iForField]))  
    Next
  Next
  
  (::cTableAliasTmp)->(DbCloseArea())
  (::cAlias)->(DbCloseArea())
  
  USE (::cTableAliasTmp) ALIAS (::cAlias) NEW EXCLUSIVE

  AdsConnection(tAds_GetConnectionDefault())

Return Nil
//-----------------------------------------------------------------------------
METHOD DsError(f_nErrorSql,f_cErrorSql,f_cSqlScript,f_cErrorComplete) Class TAds
  Local oDs_Insert
  Local oReg, cComputer := ""
  
  oReg := TReg32():New( HKEY_LOCAL_MACHINE,;
       "System\CurrentControlSet\Control\ComputerName\ComputerName" )
  cComputer:=oReg:Get("ComputerName")
  oReg:Close()

  oDs_Insert := tAds():DsNew(2,121)
  AdsBeginTransaction(tAds_GetConnectionHandle(121))

  aadd(oDs_Insert:aVarsSql,{"_Dt_Ocorrencia_",Date()})
  aadd(oDs_Insert:aVarsSql,{"_Hr_Ocorrencia_",Time()})
  aadd(oDs_Insert:aVarsSql,{"_cComputerName_",cComputer})
  aadd(oDs_Insert:aVarsSql,{"_cInfoProcLine_",st_aCtrlAlias_Monitor[::nOpenAliasCtrl]})
  aadd(oDs_Insert:aVarsSql,{"_nErrorSql_",f_nErrorSql})
  aadd(oDs_Insert:aVarsSql,{"_cErrorSql_",f_cErrorSql})
  aadd(oDs_Insert:aVarsSql,{"_cSqlScript_",f_cSqlScript})
  aadd(oDs_Insert:aVarsSql,{"_cErrorComplete_",f_cErrorComplete})
  oDs_Insert:cQrySql := "Insert Into TADS_ERR "+;
                        "(Dt_Ocorrencia, Hr_Ocorrencia, cComputerName, cInfoProcLine, nErrorSql,"+;
                        "cErrorSql, cSqlScript, cErrorComplete) "+;
                        "VALUES "+;
                        "(_Dt_Ocorrencia_, _Hr_Ocorrencia_, _cComputerName_, _cInfoProcLine_, _nErrorSql_,"+;
                        "_cErrorSql_, _cSqlScript_, _cErrorComplete_);"
  oDs_Insert:DsExecute()

  AdsCommitTransaction(tAds_GetConnectionHandle(121))

Return Nil

//-----------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
FUNCTION tAds_AliasesAutoOpened()
LOCAL nFor := 0, vText:="", cTmp := ""

  If hb_IsNil(st_aCtrlAlias_Monitor)
    Return ""
  EndIf

  FOR nFor:=1 to len(st_aCtrlAlias_Monitor)
    cTmp := st_aCtrlAlias_Monitor[nFor]
    If cTmp != "_EMPTY_"
      vText += (st_aCtrlAlias_Monitor[nFor]+CRLF)
    EndIf
  NEXT
 
Return vText
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#pragma BEGINDUMP

#define HB_OS_WIN_32_USED

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"
#include "hbinit.h"
#include "hbvm.h"
#include "rddsys.ch"
#include "hbapilng.h"
#include "hbdate.h"
#include "hbapierr.h"
#include "rddads.h"

HB_FUNC( ADSFLUSHFILEBUFFERS )  //////  giovany
{
   ADSAREAP pArea;

   pArea = (ADSAREAP) hb_rddGetCurrentWorkAreaPointer();
   if( pArea )
      AdsFlushFileBuffers( pArea->hTable );
   else
      hb_errRT_DBCMD( EG_NOTABLE, 2001, NULL, "ADSFLUSHFILEBUFFERS" );
}

#pragma ENDDUMP

