////////////////////////////////////////////////////////////////////////////////////////////////////
// Funes para operaes fisicas nas tabelas e dicionario de dados                               //
// Qualquer alterao ou modificao encaminhe para Giovany Vecchi                                //
// Giovany Vecchi 04/11/2013 giovanyvecchi@yahoo.com.br / giovanyvecchi@gmail.com                 //
////////////////////////////////////////////////////////////////////////////////////////////////////

#IFNDEF __DOS__

   #include "fivewin.ch"

#ELSE

   #include "hbclass.ch"

	#DEFINE  CRLF CHR(13)+CHR(10)

	#xtranslate MsgInfo(<cMsn>) => Alert( <cMsn> )
	#xtranslate MsgStop(<cMsn>) => Alert( <cMsn> )

   #xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  If( <uVar1> == nil, <uVar1> := <uVal1>, ) ;;
                [ If( <uVarN> == nil, <uVarN> := <uValN>, ); ]

#ENDIF

Static st_nCacheAds
Static St_aConnection, St_nConnectionDefault

FUNCTION TADS_START_CONFIG(f_cDirTmp)
  Local oConnectionTmp, cDirExpr := "", lCreateTmp := .F.
  Local aStructTmp := {}
  
  Default f_cDirTmp := CURDRIVE()+":\"+CURDIR()+"\DADOSTMP\"

	REQUEST DBFCDX , DBFFPT, DBFDBT
  REQUEST ADS ,  ADSKeyno, ADSKeycount, AdsGetRelKeyPos,  AdsSetRelKeyPos
	RddRegister( "ADS", 1 )      // ADS for Harbour
	RddSetDefault( "ADS" )       // ADS for Harbour
	AdsLocking( .T. )
	AdsRightsCheck( .F. )
	AdsTestRecLocks( .T. )
	ADSCACHEOPENTABLES( 64 )
	AdsCacheOpenCursors( 128 )
	AdsSetDateFormat( "DD/MM/YYYY" )
  AdsSetEpoch("01/01/1990")
	AdsSetFileType( 3 ) /// 1 NTX / 2 CDX / 3 ADT

	#ifdef __XHARBOUR__
		SET(_SET_HARDCOMMIT,.T.)  
	#else
		SET(106,.T.) 
	#endif

  lMkDir(f_cDirTmp)
  If !File(f_cDirTmp+"TADS_TMP.ADD")
    cDirExpr := StrTran(f_cDirTmp,"\","\\")
    AdsSetServerType(1)
    TAds_CreateDataDictionary(cDirExpr+"TADS_TMP.ADD","Dicionario de dados temporario para TAds")
    lCreateTmp := .T.
  EndIf

  oConnectionTmp := tAdsConnection():New(121,.F.)
  oConnectionTmp:cDataDictionary  := f_cDirTmp+"TADS_TMP.ADD"
  oConnectionTmp:cSenhaConnect    := "" 
  oConnectionTmp:nTpConnect       := 1
  oConnectionTmp:tAdsConnect()

  If lCreateTmp
    aadd(aStructTmp,{"STATUS","Short",2,0,1,"Status para Controle Interno",0})
    aadd(aStructTmp,{"Dt_Ocorrencia","Date",8,0,1,"Data da Ocorrencia do erro",Nil})
    aadd(aStructTmp,{"Hr_Ocorrencia","C",10,0,0,"Horas da Ocorrencia do erro",Nil})
    aadd(aStructTmp,{"cComputerName","C",50,0,0,"Nome do Computador ",Nil})
    aadd(aStructTmp,{"cInfoProcLine","C",100,0,0,"Linha e procedimento da chamada de DsNew()",Nil})
    aadd(aStructTmp,{"nErrorSql","N",7,0,0,"Numero do Erro retornado por AdsGetLastError",Nil})
    aadd(aStructTmp,{"cErrorSql","Memo",8,0,0,"Descricao do Erro retornado por AdsGetLastError",Nil})
    aadd(aStructTmp,{"cSqlScript","Memo",8,0,0,"Script Sql aplicado",Nil})
    aadd(aStructTmp,{"cErrorComplete","Memo",8,0,0,"Descrio completa do erro",Nil})

    TAds_CreateTableFromCode(121,"TADS_ERR",aStructTmp,"Tabela para registros de erros de tAds DataSet")
    
  EndIf
  
RETURN NIL
///////////////////////////////////////////////////////////////////////////////
FUNCTION tAds_GetConnectionDefault()

RETURN St_nConnectionDefault
///////////////////////////////////////////////////////////////////////////////
FUNCTION tAds_GetConnectionObj(f_nConexao)

  Default f_nConexao := St_nConnectionDefault

RETURN St_aConnection[f_nConexao]
///////////////////////////////////////////////////////////////////////////////
FUNCTION tAds_GetConnectionHandle(f_nConexao)

  Default f_nConexao := St_nConnectionDefault

RETURN St_aConnection[f_nConexao]:hConnectHandle
///////////////////////////////////////////////////////////////////////////////
Class tAdsConnection

  Data cDataDictionary    Init ""
  Data cUserLogin         Init "adssys"
  Data cSenhaConnect      Init ""
  Data nTpConnect         Init 7
  Data lConnected         Init .F.
  Data lDefault           Init .F.
  
  Data nConnection, hConnectHandle
  
  Method New() Constructor
  Method tAdsConnect
  Method tAdsCloseConnect()

EndClass
//-----------------------------------------------------------------------------
Method New(f_nConnection,f_lDefault) Class tAdsConnection

  Default f_nConnection := 1, f_lDefault := .F.
  
  ::nConnection   := f_nConnection
  ::lDefault      := f_lDefault

  If ::lDefault
    St_nConnectionDefault := f_nConnection
  EndIf
  
  If Hb_IsNil(St_aConnection)
    St_aConnection          := Array(121)
  EndIf

  If Hb_IsNil(St_nConnectionDefault)
    ::lDefault              := .T.
    St_nConnectionDefault   := f_nConnection
  EndIf

  St_aConnection[f_nConnection] := Self

Return Self
//-----------------------------------------------------------------------------
Method tAdsConnect() Class tAdsConnection
	lOCAL lConectou := .F.
	
	///? ::cDataDictionary
	
	lConectou := AdsConnect60( ::cDataDictionary,;
	                           ::nTpConnect,;
	                           ::cUserLogin,;
	                           ::cSenhaConnect,;
	                           (0x00000004+0x00000010),;
	                           @::hConnectHandle)



	If !lConectou
		Return .F.
	EndIf

	ADSCACHEOPENTABLES( 64 )
	AdsCacheOpenCursors( 128 )
  
  ::lConnected    := .T.
	
Return .T.
//-----------------------------------------------------------------------------
Method tAdsCloseConnect() Class tAdsConnection
  Local hConnectionFocus := AdsConnection()
	Local hConnectionDefault := tAds_GetConnectionObj(St_nConnectionDefault):hConnectHandle
	
	///? hConectionFocus, ::hConnectHandle, tAds_GetConnectionObj(1):hConnectHandle
	
	AdsConnection(::hConnectHandle)
	
	AdsCloseCachedTables(::hConnectHandle)
	AdsDisconnect(::hConnectHandle)
	
  If ::hConnectHandle <> hConnectionFocus
    AdsConnection(hConnectionFocus)
  Else
    AdsConnection(hConnectionDefault)
  EndIf
	
	::lConnected := .F.
	
Return NIL
//-----------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
FUNCTION nCacheAds()

  If HB_ISNIL(st_nCacheAds)
    st_nCacheAds := 100
  EndIf

Return st_nCacheAds

